searchNodes=[{"type":"module","title":"TelemetryMetricsCloudwatch","doc":"This is a Amazon CloudWatch Reporter for Telemetry.Metrics definitions. Provide a list of metric definitions to the init/2 function. It's recommended to run TelemetryMetricsCloudwatch under a supervision tree, usually under Application. def start ( _type , _args ) do # List all child processes to be supervised children = [ { TelemetryMetricsCloudwatch , [ metrics : metrics ( ) ] } ... ] opts = [ strategy : :one_for_one , name : ExampleApp.Supervisor ] Supervisor . start_link ( children , opts ) end defp metrics do [ counter ( &quot;http.request.count&quot; ) , last_value ( &quot;vm.memory.total&quot; , unit : :byte ) , last_value ( &quot;vm.total_run_queue_lengths.total&quot; ) ] end You can also provide options for the namespace used in CloudWatch (by default, &quot;Telemetry&quot;) and the minimum frequency (in milliseconds) with which data will be posted (see section below for posting rules). For instance: ... children = [ { TelemetryMetricsCloudwatch , metrics : metrics ( ) , namespace : &quot;Backend&quot; , push_interval : 30_000 } ] ... Telemetry.Metrics Types Supported TelemetryMetricsCloudwatch supports 4 of the Metrics : Counter : Counter metric keeps track of the total number of specific events emitted. LastValue : Last value keeps track of the selected measurement found in the most recent event. Summary : Summary aggregates measurement's values into statistics, e.g. minimum and maximum, mean, or percentiles. This sends every measurement to CloudWatch. Sum : Sum metric keeps track of the sum of selected measurement's values carried by specific events. If you are using Summary for a metric already, then CloudWatch can calculate a Sum using that Summary metric. If you only need a Sum (and no other summary metrics) then use this Sum metric instead. These metrics are sent to CloudWatch based on the rules described below. When Data is Sent Cloudwatch has certain constraints on the number of metrics that can be sent up at any given time. TelemetryMetricsCloudwatch will send accumulated metric data at least every minute (configurable by the :push_interval option) or when the data cache has reached the maximum size that CloudWatch will accept. Event Sampling You can optionally send only a portion of reported events to CloudWatch via the :sample_rate option. This parameter should contain a value between 0.0 and 1.0 (inclusive), and represents the proportion of events that will be reported. For instance, a sample rate value of 0.0 will ensure no events are sent, whereas a sample rate value of 1.0 will ensure all events are sent. A sample rate of 0.25 will result in roughly a quarter of all events being sent. Note: Using a sampling rate of less than 1.0 will result in incorrect values for the &quot;Sum&quot; and &quot;Counter&quot; metric types (and some of the values like min/max for the &quot;Summary&quot; metric type) due to the under-reporting of events. You should only use a sampling rate of less than 1.0 if you have a guaranteed high rate of events and only care about summary statistics like averages and percentiles. Units In order to report metrics in the CloudWatch UI, they must be one of the following values: Time units: :second , :microsecond , :millisecond Byte sizes: :byte , :kilobyte , :megabyte , :gigabyte , :terabyte Bit sizes: :bit , :kilobit , :megabit , :gigabit , :terabit For Telementry.Metrics.Counter s, the unit will always be :count . Otherwise, the unit will be treated as nil . Notes on AWS ExAws is the library used to send metrics to CloudWatch. Make sure your keys are configured and that they have the correct permissions of cloudwatch:PutMetricData . Up to 10 tags are sent up to AWS as dimensions for a given metric. Every metric name will have a suffix added based on the metric type (CloudWatch doesn't allow different units / measurements with the same name). So, for instance, if your metrics are: summary ( &quot;my_app.repo.query.total_time&quot; , unit : { :nanosecond , :millisecond } ) count ( &quot;my_app.repo.query.total_time&quot; ) Then the metric names in CloudWatch will be: my_app.repo.query.total_time.summary (with all data points recorded) my_app.repo.query.total_time.count (with the number of queries recorded)","ref":"TelemetryMetricsCloudwatch.html"},{"type":"function","title":"TelemetryMetricsCloudwatch.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"TelemetryMetricsCloudwatch.html#child_spec/1"},{"type":"function","title":"TelemetryMetricsCloudwatch.handle_telemetry_event/4","doc":"","ref":"TelemetryMetricsCloudwatch.html#handle_telemetry_event/4"},{"type":"function","title":"TelemetryMetricsCloudwatch.start_link/1","doc":"Start the TelemetryMetricsCloudwatch GenServer . Available options: :name - name of the reporter instance. :metrics - a list of Telemetry.Metrics to track. :namespace - Namespace to use in CloudWatch :push_interval - The minimum interval that metrics are guaranteed to be pushed to cloudwatch (in milliseconds) :sample_rate - Sampling factor to apply to metrics. 0.0 will deny all events, 1.0 will queue all events.","ref":"TelemetryMetricsCloudwatch.html#start_link/1"},{"type":"module","title":"TelemetryMetricsCloudwatch.Cache","doc":"State for GenServer . Nothing here should be called directly outside of the TelemetryMetricsCloudwatch module.","ref":"TelemetryMetricsCloudwatch.Cache.html"},{"type":"function","title":"TelemetryMetricsCloudwatch.Cache.max_values_per_metric/1","doc":"","ref":"TelemetryMetricsCloudwatch.Cache.html#max_values_per_metric/1"},{"type":"function","title":"TelemetryMetricsCloudwatch.Cache.metric_count/1","doc":"","ref":"TelemetryMetricsCloudwatch.Cache.html#metric_count/1"},{"type":"function","title":"TelemetryMetricsCloudwatch.Cache.pop_metrics/1","doc":"","ref":"TelemetryMetricsCloudwatch.Cache.html#pop_metrics/1"},{"type":"function","title":"TelemetryMetricsCloudwatch.Cache.push_measurement/4","doc":"","ref":"TelemetryMetricsCloudwatch.Cache.html#push_measurement/4"},{"type":"function","title":"TelemetryMetricsCloudwatch.Cache.validate_metrics/1","doc":"","ref":"TelemetryMetricsCloudwatch.Cache.html#validate_metrics/1"},{"type":"module","title":"TelemetryMetricsCloudwatch.Cloudwatch","doc":"Functions for interacting with Amazon CloudWatch .","ref":"TelemetryMetricsCloudwatch.Cloudwatch.html"},{"type":"function","title":"TelemetryMetricsCloudwatch.Cloudwatch.send_metrics/2","doc":"","ref":"TelemetryMetricsCloudwatch.Cloudwatch.html#send_metrics/2"}]